---
title: RTCRtpTransceiver.setCodecPreferences()
slug: Web/API/RTCRtpTransceiver/setCodecPreferences
tags:
  - API
  - Codec
  - Codec Configuration
  - Codec Parameters
  - Codec Preferences
  - Media
  - Method
  - RTCRtpTransceiver
  - Reference
  - Settings
  - WebRTC
  - setCodecPreferences
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The {{domxref("RTCRtpTransceiver")}} method <strong><code>setCodecPreferences()</code></strong> configures the transceiver's codecs given a list of {{domxref("RTCRtpCodecCapability")}} objects specifying the new preferences for each {{Glossary("codec")}}.</span> The specified set of codecs and configurations will be used for all future connections including this transceiver until this method is called again.</p>

<p>When preparing to open an {{domxref("RTCPeerConnection")}}, you can change the codec parameters from the {{Glossary("user agent", "user agent's")}} default configuration by calling <code>setCodecParameters()</code> <em>before</em> calling either {{domxref("RTCPeerConnection.createOffer()")}} or {{domxref("RTCPeerConnection.createAnswer", "createAnswer()")}}.</p>

<p>A guide to codecs supported by WebRTC—and each codec's positive and negative characteristics—can be found in <a href="/en-US/docs/Web/Media/Formats/WebRTC_codecs">Codecs used by WebRTC</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>rtcRtpTransceiver</em>.setCodecPreferences(<em>codecs</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>codecs</code></dt>
 <dd>
 <p>An array of {{domxref("RTCRtpCodecCapability")}} objects, in order of preference, each providing the parameters for one of the transceiver's supported codecs. If <code>codecs</code> is empty, the codec configurations are all returned to the user agent's defaults.</p>

 <div class="note"><strong>Note:</strong> Any codecs not included in <code>codecs</code> will not be considered during the process of negotiating a connection. This lets you prevent the use of codecs you don't wish to use.</div>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code></p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidAccessError</code></dt>
 <dd>The <code>codecs</code> list includes one or more codecs which are not supported by the transceiver.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Getting_a_list_of_supported_codecs">Getting a list of supported codecs</h3>

<p>You can only include in the <code>codecs</code> list codecs which the transceiver actually supports. That means that either the associated {{domxref("RTCRtpSender")}} or the {{domxref("RTCRtpReceiver")}} needs to support every codec in the list. If any unsupported codecs are listed, the browser will throw an <code>InvalidAccessError</code> exception when you call this method.</p>

<p>A good approach to setting codec preferences is to first get the list of codecs that are actually supported, then modify that list to match what you want. Pass the altered list into <code>setCodecPreferences()</code> to specify your preferences.</p>

<p>To determine which codecs are supported by the transceiver, call the sender's {{domxref("RTCRtpSender.getCapabilities", "getCapabilities()")}} and the receiver's {{domxref("RTCRtpReceiver.getCapabilities", "getCapabilities()")}} methods and get the {{domxref("RTCRtpCapabilities.codecs", "codecs")}} list from the results of each.</p>

<p>The following code snippet demonstrates how to get both the list of codecs supported by the transceiver's {{domxref("RTCRtpSender")}} and {{domxref("RTCRtpReceiver")}}.</p>

<pre class="brush: js">var availSendCodecs = transceiver.sender.getCapabilities("video").codecs;
var availReceiveCodecs = transceiver.receiver.getCapabilities("video").codecs;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("WebRTC 1.0", "#dom-rtcrtptransceiver-setcodecpreferences", "RTCRtpTransceiver.setCodecPreferences()")}}</td>
   <td>{{Spec2("WebRTC 1.0")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCRtpTransceiver.setCodecPreferences")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/Media/Formats/WebRTC_codecs">Codecs used by WebRTC</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Intro_to_RTP">Introduction to the Real-time Transport Protocol (RTP)</a></li>
 <li><a href="/en-US/docs/Web/Media">Web media technologies</a></li>
</ul>
